fhicl-cpp - Feature #25392

Improve thread safety so that the Mu2e MT workarounds are not needed.

01/12/2021 08:23 PM - Rob Kutschke

Status: Closed Start date: 01/12/2021
Priority: Normal Due date:

Assignee: Kyle Knoepfel % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 3.08.00 Spent time: 5.00 hours
Description

Kyle implemented some workarounds in the Mu2e code to avoid race conditions parsing validated fhicl in an MT environment. See
the pull request. https://github.com/Mu2e/Offline/pull/312 .

Mu2e requests that fhicl_cpp be made thread safe so that the workarounds are not needed.

History

#1 - 01/15/2021 03:23 PM - Kyle Knoepfel
- % Done changed from 0 to 100
- Assignee set to Kyle Knoepfel

- Status changed from New to Assigned

This has been implemented with commit fhicl-cpp:a0c9fd1. However, I'd like to discuss the use of thread-local storage with MT experts. Assuming
no problems, this would be available as part of art 3.08.00 (redacted from art 3.07.00).

#2 - 01/19/2021 04:31 PM - Kyle Knoepfel
- Target version set to 3.08.00

- Status changed from Assigned to Resolved

It turns out the use of thread-local storage is not properly supported for e19:prof builds. A different implementation is thus provided with commit
fhicl-cpp:a284b6.

#3 - 03/09/2021 02:35 PM - Kyle Knoepfel

- Status changed from Resolved to Closed
